#include <click/config.h>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/glue.hh>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "flowshaper.hh"

//typedef enum debug_level { NONE, LOW, MEDIUM, HIGH };
//debug_level debug = HIGH;

CLICK_DECLS

FlowShaper::FlowShaper() {}

FlowShaper::~ FlowShaper() {}

int FlowShaper :: timeval_gre (struct timeval *t1,struct timeval *t2)
{

  

  if((t2->tv_sec)>(t1->tv_sec))
  {  
       return 1; 
  }
 else if((t2->tv_sec)==(t1->tv_sec))
  {
      if((t2->tv_usec)>=(t1->tv_usec))
        return 1;
      else
        return 0;
  }
        return 0;

}

void FlowShaper :: timeval_add (struct timeval *t1,unsigned int k){
  
  if(k<(1000000-t1->tv_usec))
  {
    t1->tv_usec=t1->tv_usec+k;
  }
  else
  {  t1->tv_sec+=1;
     t1->tv_usec=(t1->tv_usec+k-1000000);
  }
  
}

void FlowShaper :: timeval_assign (struct timeval *t1,struct timeval *t2)

{

   t1->tv_sec = t2->tv_sec ;
   t1->tv_usec = t2->tv_usec;
}
/*double FlowShaper :: timeval_diff (struct timeval *t1, struct timeval *t2)

{

   double diff;
diff = (t1->tv_sec - t2->tv_sec) + (t1->tv_usec - t2->tv_usec) / 1000000.0;

   return diff;

}*/

int FlowShaper :: configure(Vector<String> &conf, ErrorHandler *errh) {
    count = 0;

    if ( cp_va_parse(conf, this, errh, 
         cpOptional,
         cpString, "label", &_label,
         cpKeywords, 
         "MAX_SIZE", cpInteger, "maximum packet size", &maxSize, 
         "MAX_RATE", cpInteger, "maximum traffic rate", &maxRate, 
          cpEnd) < 0) {
       return -1;
    }

    if (maxSize <= 0) {
       maxSize = MAX_SIZE;
       return errh->error("maxsize should be larger than 0");
    }

    if (maxRate <= 0) {
       maxRate = MAX_RATE;
       // return errh->error("maxrate should be larger than 0");
    }

    
    return 0;
}

Packet* FlowShaper::simple_action(Packet *p){
  int k;
  static int j,l;  
  unsigned int len;
  click_gettimeofday(&curr_time);
  len = p->length();
   
  j++;//Updates the counter of Total number of packets
  if(j==1)
  {
     l++;//Updates the counter of Conforming packets
     timeval_assign(&TAT,&curr_time);
     timeval_add(&TAT,len*1/2);
  }
  else 
  {
     k=timeval_gre(&TAT,&curr_time);
     if(k==1)
     {  
        l++;//Updates the counter of Conforming packets
        timeval_assign(&TAT,&curr_time);
        len=p->length();
        printf("In range-%d\n ",l);
           
        timeval_add(&TAT,len*1/2);
     }
     else 
     {
        timeval_assign(&start_time,&curr_time);
        timeval_add(&start_time,750);
        k=timeval_gre(&TAT,&start_time);

        if(k==1)
        {
           l++;//Updates the counter of Conforming packets
           printf("In range-%d\n",l);
           timeval_add(&TAT,len*1/2);
        }
        else
        { 
           printf(" Out of range\n");//Non-Conforming
           /*Dropping of selective lines is done by the two lines below. I think the problem lies here.*/
           p->kill();
           return NULL;
        }
     }
  }

  return p;
}
CLICK_ENDDECLS
EXPORT_ELEMENT(FlowShaper)
