#ifndef CLICK_FLOWSHAPER_HH
#define CLICK_FLOWSHAPER_HH

#include <click/element.hh>

CLICK_DECLS

enum { MAX_SIZE = 500, MAX_RATE = 2000 };

class FlowShaper : public Element {
    public:
        FlowShaper();
        ~FlowShaper();

        const char *class_name() const  { return "FlowShaper"; }
        const char *port_count() const  { return PORTS_1_1; }
        const char *processing() const  { return AGNOSTIC; }

        int configure(Vector<String>&, ErrorHandler*);
        double timeval_diff (struct timeval *t1, struct timeval *t2);
          void timeval_add (struct timeval*, unsigned int);
        int  timeval_gre (struct timeval*, struct timeval*);
void timeval_assign(struct timeval*,  struct timeval*);
        Packet *simple_action(Packet *);

    private:
        String _label;

        uint32_t maxSize;
        uint32_t maxRate;
        uint32_t totalTraffic;
        struct timeval start_time, last_time, curr_time,TAT;
        double rate;
        uint32_t count;
};

CLICK_ENDDECLS

#endif
